//############################################################################
//Funktionen zur Laufzeitmessung
//@author diehl@ins.uni-bonn.de
//@date 10-01-2013
//############################################################################

#ifndef UTIL_H
#define UTIL_H

#include <time.h>
#include <sys/time.h>
#include <stdlib.h>

#define MIN 0
#define MAX 100000

//Variablen für die Zeit
struct timeval start, stop;

/**
 * Beginnt die Messung der Zeit
 */
void
beginTime ()
{
  gettimeofday (&start, 0);
}

/**
 * Gibt die Zeit, die zwischen beginTime() und endTime() vergangen ist, zurück
 * @return Laufzeit
 */
float
endTime ()
{
  gettimeofday (&stop, 0);

  double begin = (double) start.tv_sec + (double) (start.tv_usec / 1.E6);

  double end = (double) stop.tv_sec + (double) (stop.tv_usec / 1.E6);

  return end - begin;
}

/**
 * Befüllt das Array mit gleichverteilten Zufallszahlen
 * @param array Das zubefuellende Array
 * @param length Laenge des Arrays
 */
void
randomArray (double *array, int length)
{
  for (int i = 0; i < length; ++i)
    {
      array[i] =
	(double) (rand () /
	       (((double) RAND_MAX + 1) / (double) (MAX - MIN + 1))) + MIN;
    }
}


#endif
